﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace BookNC
{
    public partial class Book_search : Form
    {
		//variable
		//connection
		System.Data.OleDb.OleDbConnection DbConnection1 = new System.Data.OleDb.OleDbConnection();

		//Select command
		System.Data.OleDb.OleDbCommand vselect;
		//Dataadapter
		System.Data.OleDb.OleDbDataAdapter vda;
		System.Data.DataSet vdset;
		string vitem_grid;
		bool searchflg;
		bool s_flag;

		// public variables
		public class BookSearch_cl
		{
			public static int book_recno;
			public static string findedit_Flag;
		}

		public Book_search()
        {
            InitializeComponent();
        }

        private void Book_search_Load(object sender, EventArgs e)
        {
			int vleft;
			int vtop;

			BookForm FBookForm = new BookForm();

			this.DbConnection1.ConnectionString = @"Provider=""Microsoft.Jet.OLEDB.4.0"";Data Source=""C:\Users\chk\source\repos\BookNC\data\Book_VC19.mdb"";Persist Security Info=False;User ID=Admin;Mode=Share Deny None;Jet OLEDB:Engine Type=5;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Global Bulk Transactions=1;Jet OLEDB:Create System Database=False;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;Jet OLEDB:SFP=False";


			// Move

			vleft = BookNC.BookForm.BookF_cl.booknote_left + BookNC.BookForm.BookF_cl.booknote_width - this.Width;
			vtop = BookNC.BookForm.BookF_cl.booknote_top;

			this.Location = new System.Drawing.Point(vleft, vtop);

			//resize
			this.Btnsearch.Left = (this.Panel113.Width - this.Btnsearch.Width) / 2;

			this.Btnok.Top = (this.Panel114.Height - this.Btnok.Height) / 2;
			this.Btncancel.Top = this.Btnok.Top;

			this.Pic_line011.Top = this.Btnok.Top + ((this.Btnok.Height - (this.Pic_line011.Height * 3)) / 4);
			this.Pic_line012.Top = this.Pic_line011.Top + this.Pic_line011.Height + ((this.Btnok.Height - (this.Pic_line011.Height * 3)) / 4);
			this.Pic_line013.Top = this.Pic_line012.Top + this.Pic_line012.Height + ((this.Btnok.Height - (this.Pic_line011.Height * 3)) / 4);

			this.Pic_line011.Left = (this.Btnok.Left - this.Pic_line011.Width) / 2;
			this.Pic_line012.Left = this.Pic_line011.Left;
			this.Pic_line013.Left = this.Pic_line011.Left;

			s_flag = false;
			searchflg = false;
			sub_clearall();

			switch (BookNC.BookForm.BookF_cl.booknote_type)
			{
				case "find":
					this.Text = "search, book note ...";
					break;
				case "edit":
					this.Text = "edit, book note ...";
					break;
			}

			this.Chk_allbook.Checked = true;

			sub_load("name");
			sub_load("first");
			sub_load("father");
			sub_load("city");

			sub_search("", "", "", "", "", "");


		}

		//add data to comboboxes
		private void sub_load(string v_field)
		{
			int i;

			switch (v_field)
			{
				case "name":
					vselect = new System.Data.OleDb.OleDbCommand("SELECT DISTINCT Trim(name) AS vname FROM book WHERE (Trim(name) <> '') ORDER BY  Trim(name)");
					break;
				case "first":
					vselect = new System.Data.OleDb.OleDbCommand("SELECT DISTINCT Trim(first_name) AS vfirst FROM book WHERE (Trim(first_name) <>'')ORDER BY Trim(first_name)");
					break;
				case "father":
					vselect = new System.Data.OleDb.OleDbCommand("SELECT DISTINCT Trim(father_name) AS vfather FROM book WHERE (Trim(father_name) <>'')ORDER BY Trim(father_name)");
					break;
				case "city":
					vselect = new System.Data.OleDb.OleDbCommand("SELECT DISTINCT Trim(city) AS vcity FROM book WHERE (Trim(city)<>'')ORDER BY Trim(city)");
					break;
			}

			vda = new System.Data.OleDb.OleDbDataAdapter(vselect);
			vdset = new System.Data.DataSet();

			vselect.Connection = DbConnection1;

			vdset.EnforceConstraints = false;
			try
			{
				DbConnection1.Open();
				vda.Fill(vdset, "book");
			}
			catch (System.Exception fillException)
			{
				System.Windows.Forms.MessageBox.Show(fillException.Message);
			}
			vdset.EnforceConstraints = true;
			DbConnection1.Close();

			if (vdset.Tables["book"].Rows.Count > 0)
			{
				for (i = 0; i <= (vdset.Tables["book"].Rows.Count - 1); i++)
				{

					switch (v_field)
					{
						case "name":
							this.Cmbname.Items.Add(vdset.Tables["book"].Rows[i]["vname"].ToString().Trim());
							break;
						case "first":
							this.Cmbfirst.Items.Add(vdset.Tables["book"].Rows[i]["vfirst"].ToString().Trim());
							break;
						case "father":
							this.Cmbfather.Items.Add(vdset.Tables["book"].Rows[i]["vfather"].ToString().Trim());
							break;
						case "city":
							this.Cmbcity.Items.Add(vdset.Tables["book"].Rows[i]["vcity"].ToString().Trim());
							break;
					}
				}
			}
		}

		private void Cmbname_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (s_flag == true)
				sub_check();
		}

		private void sub_check()
		{
			if (this.Chk_allbook.Checked == true)
				this.Chk_allbook.Checked = false;
			if (this.Btnsearch.Enabled == false)
				this.Btnsearch.Enabled = true;
		}

		private void Cmbfirst_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (s_flag == true)
				sub_check();
		}

		private void Cmbfather_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (s_flag == true)
				sub_check();
		}

		private void Cmbcountry_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (s_flag == true)
				sub_check();
		}

		private void Cmbcity_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (s_flag == true)
				sub_check();
		}

		private void Txtphone_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (s_flag == true)
				sub_check();
		}

		private void Chk_condition_CheckedChanged(object sender, EventArgs e)
		{
			if (this.Chk_condition.Checked == true)
				this.lcondition.Text = "condition - Or";

			if (this.Chk_condition.Checked == false)
				this.lcondition.Text = "condition - And";
		}

		private void Chk_allbook_CheckedChanged(object sender, EventArgs e)
		{
			if ((s_flag == true) && (this.Chk_allbook.Checked == true))
			{
				if (this.Btnsearch.Enabled == false)
					this.Btnsearch.Enabled = true;
			}
		}

		private void Btnclear_Click(object sender, EventArgs e)
		{
			sub_clearall();
		}

		private void sub_clearall()
		{
			this.Cmbname.SelectedIndex = -1;
			this.Cmbfirst.SelectedIndex = -1;
			this.Cmbfather.SelectedIndex = -1;
			this.Cmbcountry.SelectedIndex = -1;
			this.Cmbcity.SelectedIndex = -1;
			this.Txtphone.Text = "";
			if (this.Btnsearch.Enabled == true)
				this.Btnsearch.Enabled = false;
		}

		private void Btnsearch_Click(object sender, EventArgs e)
		{
			searchflg = true;
			switch (this.Chk_allbook.Checked)
			{
				case true:
					sub_search("", "", "", "", "", "");
					break;
				case false:
					sub_search(this.Cmbname.Text.Trim(), this.Cmbfirst.Text.Trim(), this.Cmbfather.Text.Trim(), this.Cmbcountry.Text.Trim(), this.Cmbcity.Text.Trim(), this.Txtphone.Text.Trim());
					break;
			}
		}

		private void sub_search(string v_name, string v_firstname, string v_fathername, string v_country, string v_city, string v_phone)
		{
			int vfound;

			switch (this.Chk_allbook.Checked)
			{
				case true:
					vselect = new System.Data.OleDb.OleDbCommand("SELECT bookid,alternativePhone, city, country, father_name, fax, first_name, homephone, mobilephone, name, sex, workphone FROM book WHERE (name <> '') ORDER BY name, first_name, father_name");
					break;
				case false:
					vselect = new System.Data.OleDb.OleDbCommand("SELECT bookid,alternativePhone, city, country, father_name, fax, first_name, homephone, mobilephone, name, sex, workphone FROM book WHERE ((name <> '') And (Trim(name) = '" + v_name + "') Or (Trim(first_name) =  '" + v_firstname + "') Or (Trim(father_name)  = '" + v_fathername + "') Or (Trim(country)  = '" + v_country + "') Or (Trim(city)  = '" + v_city + "') Or ((Trim(homephone) =  '" + v_phone + "') Or (Trim(workphone) =  '" + v_phone + "') Or (Trim(mobilephone) =  '" + v_phone + "') Or (Trim(alternativePhone) =  '" + v_phone + "') Or (Trim(fax) =  '" + v_phone + "'))) ORDER BY name, first_name, father_name");
					break;
			}

			vda = new System.Data.OleDb.OleDbDataAdapter(vselect);
			vdset = new System.Data.DataSet();

			vselect.Connection = DbConnection1;

			vdset.EnforceConstraints = false;
			try
			{
				DbConnection1.Open();
				vda.Fill(vdset, "book");
			}
			catch (System.Exception fillException)
			{
				System.Windows.Forms.MessageBox.Show(fillException.Message);
			}
			vdset.EnforceConstraints = true;
			DbConnection1.Close();

			vfound = vdset.Tables["book"].Rows.Count;
			this.DataGrid1.DataSource = vdset;
			this.DataGrid1.DataMember = "book";

			if (searchflg == true)
			{
				this.Btnsearch.Enabled = true;
				this.Btnclear_Click(Btnclear, null);
				searchflg = false;
			}

			switch (this.Chk_allbook.Checked)
			{
				case true:
					this.lbfound.Text = vfound.ToString() + " - item(s) found, selected: all book(s)";
					break;
				case false:
					this.lbfound.Text = vfound.ToString() + " - item(s) found";
					break;
			}
			s_flag = true;
			this.lbfound.Focus();
		}

		private void sub_select()
		{
			int vvrec;

			vselect = new System.Data.OleDb.OleDbCommand("SELECT  bookid, country, father_name, first_name, name, sex FROM book WHERE (name <> '') ORDER BY bookid");

			vda = new System.Data.OleDb.OleDbDataAdapter(vselect);
			vdset = new System.Data.DataSet();

			vselect.Connection = DbConnection1;

			vdset.EnforceConstraints = false;
			try
			{
				DbConnection1.Open();
				vda.Fill(vdset, "book");
			}
			catch (System.Exception fillException)
			{
				System.Windows.Forms.MessageBox.Show(fillException.Message);
			}
			vdset.EnforceConstraints = true;
			DbConnection1.Close();

			if (vdset.Tables["book"].Rows.Count > 0)
			{
				for (vvrec = 0; vvrec <= (vdset.Tables["book"].Rows.Count - 1); vvrec++)
				{
					if (vdset.Tables["book"].Rows[vvrec]["bookid"].ToString().Trim() == vitem_grid.Trim())
					{
						BookSearch_cl.book_recno = vvrec;

					}
				}
			}
		}

		private void DataGrid1_Click(object sender, EventArgs e)
		{
			vitem_grid = this.DataGrid1[this.DataGrid1.CurrentRowIndex, 0].ToString();
			this.Btnok.Enabled = true;
		}

		private void DataGrid1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			vitem_grid = this.DataGrid1[this.DataGrid1.CurrentRowIndex, 0].ToString();
			this.Btnok.Enabled = true;
		}

		private void Btnok_Click(object sender, EventArgs e)
		{
			sub_select();
			BookSearch_cl.findedit_Flag = "ok";

			switch (BookNC.BookForm.BookF_cl.booknote_type)
			{
				case "find":
					this.Close();
					BookNC.BookForm.ActiveForm.Refresh();
					BookNC.BookForm.ActiveForm.Activate();
					//fbooknote.sub_findok();
					break;
				case "edit":
					this.Close();
					BookNC.BookForm.ActiveForm.Refresh();
					BookNC.BookForm.ActiveForm.Activate();
					//fbooknote.sub_modifyok();
					break;
			}
		}

		private void Btncancel_Click(object sender, EventArgs e)
		{
			BookSearch_cl.findedit_Flag = "cancel";
			this.Close();
			BookNC.BookForm.ActiveForm.Refresh();
			BookNC.BookForm.ActiveForm.Activate();

		}

       
    }
}

